#ifndef _EYD_BITWRITER_HH
#define _EYD_BITWRITER_HH

#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <exception>
#include "eyd_bitgroup.hh"

#include "eyd_global.hh"
#include "eyd_iface.hh"


namespace EydLib {
	class eBitWriterOutOfBound : public std::exception { };
	class eBitWriterBadFileDescriptor : public std::exception { };

	class BitWriter {
		private:
			int _bitgroup_size;
			int _real_buffer_size_in_bits;
			int _wanted_buffer_size;
			char * _write_buffer;
			int _file_desc;
			int _current_bit_position;
			bool _ready;
	
			void setBitAt(int position, bool value);

		public:
			BitWriter(int size, int buffer_size);
			~BitWriter();

			void init(int size);
			void open(std::string filename);
			void write(BitGroup data);
			ssize_t writeDirect(void *buf, size_t count);
			void flush();
			void close();
	};
}

#endif
