#ifndef _EYD_BITCOMPRESSOR_HH
#define _EYD_BITCOMPRESSOR_HH

#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <exception>

#include "eyd_bitgroup.hh"

#include "eyd_global.hh"
#include "eyd_iface.hh"


namespace EydLib {

	class BitCompressorRle1 {
		private:
			BitGroup _rle;
			BitGroup _last_group;
			int _last_count;
			int _group_size;
			std::list<BitGroup> _compressed;


		public:
			BitCompressorRle1::BitCompressorRle1(int size);

			void clear();
			void append(BitGroup bg);
			std::list<BitGroup> flush();
			bool hasContent();

			void flushRleData();
			void flushRawData();

	};
}

#endif
